#pragma once

#include "FrameOperation.h"
#include "OverlayMode.h"

#include "atltypes.h"

class FieldPatch : public PatchOperationWithSource
{
private:
	~FieldPatch() {}
private: // attributes
	LONG m_targetOrder;
	LONG m_sourceOrder;
	HOverlay m_mode;
public:
	LONG targetOrder() const;
	LONG sourceOrder() const;

	HOverlay mode() const;
	void setMode(HOverlay mode);

	bool usesFrame(LONG frame) const;

public:
	explicit FieldPatch(CVclipDoc& owner, 
		LONG sourceFrame = 0, LONG sourceOrder = 0, int sourceX = 0, int sourceY = 0, int sourceWidth = 0, int sourceHeight = 0,
		LONG targetFrame = 0, LONG targetOrder = 0, int targetX = 0, int targetY = 0, int targetWidth = 0, int targetHeight = 0,
		HOverlay mode = the<Overlays>()["Blend"]);
	
	const char* typeCode() const;
	void writeTo(std::ostream& stream) const;
	void readFieldPatch(std::istream& stream);
	void readFieldPatch2(std::istream& stream);

	void accept(IOperationVisitor& visitor);
};
