#include "stdafx.h"

#include "FieldRebuild.h"

CreateFrameOperation<FieldRebuild, &FieldRebuild::readFrom> g_createFieldRebuild("FieldRebuild");

FieldRebuild::FieldRebuild(CVclipDoc& owner, LONG targetFrame /*= 0*/)
: FrameOperation(owner, targetFrame)
{
}

bool FieldRebuild::usesFrame(LONG frame) const
{
	return abs(frame - targetFrame()) == 1;
}

const char* FieldRebuild::typeCode() const
{
	return "FieldRebuild";
}

void FieldRebuild::writeTo(std::ostream& stream) const
{
	stream << targetFrame();
}

void FieldRebuild::readFrom(std::istream& stream)
{
	LONG targetFrame;
	stream >> targetFrame;
	setTargetFrame(targetFrame);
}

void FieldRebuild::accept(IOperationVisitor& visitor)
{
	visitor(*this);
}
