#pragma once

#include "FrameOperation.h"

#include <string>

class FrameImage : public FrameOperation
{
private:
	~FrameImage() {}

private: // attributes
	std::string m_fileName;
public:
	const std::string& fileName() const;

	bool usesFrame(LONG frame) const;

public:
	explicit FrameImage(CVclipDoc& owner, 
		LONG targetFrame = 0, const std::string& fileName = std::string());

public: // serialization
	const char* typeCode() const;
	void writeTo(std::ostream& stream) const;
	void readFrom(std::istream& stream);

public: // everything else
	void accept(IOperationVisitor& visitor);
};

