#pragma once

template <typename OperationT, void (OperationT::* doRead)(std::istream&)>
CreateFrameOperation<OperationT, doRead>::CreateFrameOperation(const char* typeCode)
{
	the<FrameOperationFactory>().insert(typeCode, *this);
}

template <typename OperationT, void (OperationT::* doRead)(std::istream&)>
PFrameOperation CreateFrameOperation<OperationT, doRead>::operator()(CVclipDoc& owner) const
{
	return PFrameOperation(new OperationT(owner));
}

template <typename OperationT, void (OperationT::* doRead)(std::istream&)>
void CreateFrameOperation<OperationT, doRead>::read(std::istream& stream, const PFrameOperation& result) const
{
	(static_cast<OperationT&>(*result).*doRead)(stream);
}
