#pragma once

#include "FrameOperation.h"
#include "OverlayMode.h"

#include "atltypes.h"

class FramePatch : public PatchOperationWithSource
{
private:
	~FramePatch() {}
private: // attributes
	HOverlay m_mode;
public:
	HOverlay mode() const;
	void setMode(HOverlay mode);

	bool usesFrame(LONG frame) const;

public:
	explicit FramePatch(CVclipDoc& owner, 
		LONG sourceFrame = 0, int sourceX = 0, int sourceY = 0, int sourceWidth = 0, int sourceHeight = 0,
		LONG targetFrame = 0, int targetX = 0, int targetY = 0, int targetWidth = 0, int targetHeight = 0, 
		HOverlay mode = Overlays::instance()["Blend"]);
	
	const char* typeCode() const;
	void writeTo(std::ostream& stream) const;
	void readFramePatch(std::istream& stream);
	void readFramePatch2(std::istream& stream);

	void accept(IOperationVisitor& visitor);
};

