// GotoFrame.cpp : implementation file
//

#include "stdafx.h"
#include "vclip.h"
#include "GotoFrame.h"
#include "MediaTime.h"


// CGotoFrame dialog

IMPLEMENT_DYNAMIC(CGotoFrame, CDialog)
CGotoFrame::CGotoFrame(CWnd* pParent /*=NULL*/)
	: CDialog(CGotoFrame::IDD, pParent)
{
}

CGotoFrame::~CGotoFrame()
{
}

void CGotoFrame::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Radio(pDX, IDC_GOTO_FRAME, m_goto);

	if (goto_frame == m_goto || !pDX->m_bSaveAndValidate)
	{
		DDX_Text(pDX, IDC_FRAME, m_frame);
		DDV_MinMaxLong(pDX, m_frame, 0, m_frames - 1);
	}
	if (goto_time == m_goto || !pDX->m_bSaveAndValidate)
	{
		DDX_MediaTime(pDX, IDC_TIME, m_time);
		DDV_MediaTime(pDX, m_time, 0, mediaTimeFromFrame(m_frames, m_millifps) - 1);
	}
}


BEGIN_MESSAGE_MAP(CGotoFrame, CDialog)
	ON_BN_CLICKED(IDC_GOTO_FRAME, OnBnClickedGotoFrame)
	ON_BN_CLICKED(IDC_GOTO_TIME, OnBnClickedGotoTime)
	ON_EN_CHANGE(IDC_FRAME, OnEnChangeFrame)
	ON_EN_CHANGE(IDC_TIME, OnEnChangeTime)
	ON_BN_SETFOCUS(IDC_GOTO_FRAME, OnBnSetfocusGotoFrame)
	ON_BN_SETFOCUS(IDC_GOTO_TIME, OnBnSetfocusGotoTime)
END_MESSAGE_MAP()


// CGotoFrame message handlers

void CGotoFrame::OnBnClickedGotoFrame()
{
	GotoDlgCtrl(GetDlgItem(IDC_FRAME));
}

void CGotoFrame::OnBnClickedGotoTime()
{
	GotoDlgCtrl(GetDlgItem(IDC_TIME));
}

void CGotoFrame::OnEnChangeFrame()
{
	CheckRadioButton(IDC_GOTO_FRAME, IDC_GOTO_TIME, IDC_GOTO_FRAME);
}

void CGotoFrame::OnEnChangeTime()
{
	CheckRadioButton(IDC_GOTO_FRAME, IDC_GOTO_TIME, IDC_GOTO_TIME);
}

INT_PTR CGotoFrame::DoModal()
{
	m_goto = goto_frame;
	m_time = mediaTimeFromFrame(m_frame, m_millifps);
	INT_PTR result = CDialog::DoModal();
	if (IDOK == result)
	{
		if (m_goto == goto_time)
		{
			m_frame = frameFromMediaTime(m_time, m_millifps);
		}
	}
	return result;
}

LONG CGotoFrame::GetFrame() const
{
	return m_frame;
}

void CGotoFrame::SetFrame(LONG frame)
{
	m_frame = frame;
}

void CGotoFrame::SetFps(LONG millifps)
{
	m_millifps = millifps;
}

void CGotoFrame::SetFrames(LONG frames)
{
	m_frames = frames;
}

void CGotoFrame::OnBnSetfocusGotoFrame()
{
	GotoDlgCtrl(GetDlgItem(IDC_FRAME));
}

void CGotoFrame::OnBnSetfocusGotoTime()
{
	GotoDlgCtrl(GetDlgItem(IDC_TIME));
}
