// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "vclip.h"

#include "MainFrm.h"

#include "exception.h"
#include <exception>
#include <stdexcept>

#include ".\mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_FRAME,
	ID_INDICATOR_MEDIATIME,
	ID_INDICATOR_FPS/*,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,*/
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	CoInitialize(0);
}

CMainFrame::~CMainFrame()
{
	CoUninitialize();
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers

std::ostringstream TraceContext::s_trace;

BOOL CMainFrame::OnWndMsg(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	try
	{
		TraceContext::clear();
		return CFrameWnd::OnWndMsg(message, wParam, lParam, pResult);
	}
	catch (CException* e)
	{
		char error[512];
		e->GetErrorMessage(error, sizeof(error));

		CString message;
		message.Format("%s\r\n%s", error, TraceContext::trace().c_str());

		AfxMessageBox(message, MB_OK | MB_ICONWARNING);

		e->Delete();
		return FALSE;
	}
	catch (const std::exception& e)
	{
		CString message;
		message.Format("%s\r\n%s", e.what(), TraceContext::trace().c_str());

		AfxMessageBox(message, MB_OK | MB_ICONWARNING);

		return FALSE;
	}
	catch (...)
	{
		CString message;
		message.Format("An unknown error happened\n%s", TraceContext::trace().c_str());

		AfxMessageBox(message, MB_OK | MB_ICONWARNING);

		return FALSE;
	}
}
