#include "stdafx.h"

#include "MotionInterpolate.h"

CreateFrameOperation<MotionInterpolate, &MotionInterpolate::readFrom> g_createMotionInterpolate("MotionInterpolate");

MotionInterpolate::MotionInterpolate(CVclipDoc& owner, LONG targetFrame /*= 0*/)
: FrameOperation(owner, targetFrame)
{
}

bool MotionInterpolate::usesFrame(LONG frame) const
{
	return false;
}

const char* MotionInterpolate::typeCode() const
{
	return "MotionInterpolate";
}

void MotionInterpolate::writeTo(std::ostream& stream) const
{
	stream << targetFrame();
}

void MotionInterpolate::readFrom(std::istream& stream)
{
	LONG targetFrame;
	stream >> targetFrame;
	setTargetFrame(targetFrame);
}

void MotionInterpolate::accept(IOperationVisitor& visitor)
{
	visitor(*this);
}
